#include "easygen.h"
#include "easygen.cpp"

#include <algorithm>
#include <iostream>

using namespace std;

const int maxn = 200001;

int seq[maxn], n;

int dist(int i, int j)
{
   return min(abs((i-j+n)%n), abs((j-i+n)%n));
}

int main(int argc, char* argv[])
{
   try {
      testInfo a(argc, argv);
      int mode = a.getIntParam("mode"), mx = a.getIntParam("mx");
      n = a.getIntParam("n");
      if (mode) {
         int L = a.getIntParam("L"), R = a.getIntParam("R");
         seq[L] = genRandInt(n, mx); seq[R] = genRandInt(n, mx);
         for (int i = 1; i <= n; i++) if (i != L && i != R) {
            int t1 = seq[L] + dist(L, R) - dist(i, R);
            int t2 = seq[R] + dist(L, R) - dist(i, L);
            seq[i] = genRandInt(1, min(t1, t2));
         }
      } else {
         for (int i = 1; i <= n; i++) seq[i] = genRandInt(1, mx);
      }
      for (int i = 1; i <= n; i++) a["a"][i]["num"] = seq[i];
   } catch (genError a) {
      cout << a.err();
   }
   return 0;
}