#include <iostream>
#include <algorithm>

using namespace std;

const int maxn = 200000;

int n, a[maxn];
int b[maxn], c[maxn];

int dist(int i, int j)
{
   return min(abs((i-j+n)%n), abs((j-i+n)%n));
}

int solve()
{
   int best = -1, i, k;
   for (i = 1; i <= n/2; i++) {
      best = max(best, a[i]+i);
      b[i] = best;
   }
   int ans = 0;
   for (k = 0; k < n; k++) {
      int t = k+n/2;
      ans = max(ans, b[t%n] - k + a[k]);
      b[(t+1)%n] = max(b[t%n], a[(t+1)%n]+t+1);
   }
   return ans;
}

int sol_it()
{
   int ans = 0, i, j = 0;
   for (i = 0; i < n; i++) {
      if (a[i] > a[j]) j = i;
   }
   for (i = 0; i < n; i++)
      if (i != j) ans = max(ans, dist(i, j) + a[i]);
   
   if (ans <= a[j]) {
      ans += a[j];
   } else {
      ans = solve();
      for (i = 0; i < (n+1)/2; i++) swap(a[i], a[n-i-1]);
      int ans1 = solve();
      ans = max(ans, ans1);
      for (i = 0; i < (n+1)/2; i++) swap(a[i], a[n-i-1]);
   }
   return ans;
}

int sol_az()
{
  int ans = 0, k = 0, curr = 0;
  for(int i = 0; i < n; i++){
    ans = max(ans, a[i] + min(curr + k, curr + n - k));
    if(a[i] >= curr + k){
      curr = a[i]; k = 0;
    }
    k++;
  }
  k = 0; curr = 0;
  for(int i = n-1; i >= 0; i--){
    ans = max(ans, a[i] + min(curr + k, curr + n - k));
    if(a[i] >= curr + k){
      curr = a[i]; k = 0;
    }
    k++;
  }
  return ans;
}

int main()
{
   freopen("input.txt", "w", stdout);
   
   int i, j;

   n = 199999;
   srand(1000000007);
   for (i = 1; i < 10000; i++) {
      for (j = 0; j < n; j++) a[j] = rand()%1000000000 + 1;
      int t1 = sol_it();
      int t3 = sol_az();
      if (t1 != t3) break;
   }
   cout << n << endl;
   for (j = 0; j < n; j++) cout << a[j] << " ";

   fclose(stdout);
   return 0;
}